import { Module, Args_tryResolveUri, Args_getFile, Bytes, UriResolver_MaybeUriOrManifest, Client } from "./wrap";
import { PluginFactory } from "@polywrap/core-js";
export interface IpfsResolverPluginConfig extends Record<string, unknown> {
    provider: string;
    fallbackProviders?: string[];
}
export declare class IpfsResolverPlugin extends Module<IpfsResolverPluginConfig> {
    tryResolveUri(args: Args_tryResolveUri, _client: Client): Promise<UriResolver_MaybeUriOrManifest | null>;
    getFile(args: Args_getFile, client: Client): Promise<Bytes | null>;
    private static isCID;
}
export declare const ipfsResolverPlugin: PluginFactory<IpfsResolverPluginConfig>;
export declare const plugin: PluginFactory<IpfsResolverPluginConfig>;
