import * as Types from "./";
import { Client, InvokeResult } from "@polywrap/core-js";
export declare type UInt = number;
export declare type UInt8 = number;
export declare type UInt16 = number;
export declare type UInt32 = number;
export declare type Int = number;
export declare type Int8 = number;
export declare type Int16 = number;
export declare type Int32 = number;
export declare type Bytes = Uint8Array;
export declare type BigInt = string;
export declare type BigNumber = string;
export declare type Json = string;
export declare type String = string;
export declare type Boolean = boolean;
export interface UriResolver_MaybeUriOrManifest {
    uri?: Types.String | null;
    manifest?: Types.String | null;
}
export interface Ipfs_Options {
    timeout?: Types.UInt32 | null;
    provider?: Types.String | null;
    disableParallelRequests?: Types.Boolean | null;
}
export interface Ipfs_ResolveResult {
    cid: Types.String;
    provider: Types.String;
}
interface UriResolver_Module_Args_tryResolveUri extends Record<string, unknown> {
    authority: Types.String;
    path: Types.String;
}
interface UriResolver_Module_Args_getFile extends Record<string, unknown> {
    path: Types.String;
}
export declare const UriResolver_Module: {
    tryResolveUri: (args: UriResolver_Module_Args_tryResolveUri, client: Client) => Promise<InvokeResult<Types.UriResolver_MaybeUriOrManifest | null>>;
    getFile: (args: UriResolver_Module_Args_getFile, client: Client) => Promise<InvokeResult<Types.Bytes | null>>;
};
interface Ipfs_Module_Args_cat extends Record<string, unknown> {
    cid: Types.String;
    options?: Types.Ipfs_Options | null;
}
interface Ipfs_Module_Args_resolve extends Record<string, unknown> {
    cid: Types.String;
    options?: Types.Ipfs_Options | null;
}
interface Ipfs_Module_Args_addFile extends Record<string, unknown> {
    data: Types.Bytes;
}
export declare const Ipfs_Module: {
    cat: (args: Ipfs_Module_Args_cat, client: Client) => Promise<InvokeResult<Types.Bytes>>;
    resolve: (args: Ipfs_Module_Args_resolve, client: Client) => Promise<InvokeResult<Types.Ipfs_ResolveResult | null>>;
    addFile: (args: Ipfs_Module_Args_addFile, client: Client) => Promise<InvokeResult<Types.String>>;
};
export {};
